package com.example.simplenneuron;


import android.util.Log;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
//--------------------------------------------------------------
//
// Разработка нейронной сети на JAVA в Android Studio "с нуля"
// За образец возьмем GitHUB проект https://www.infoworld.com/article/3685569/how-to-build-a-neural-network-in-java.html
// Нейронная сеть состоит из 6 нейронов: 3 входных, 2 нейрона в скрытом (внутреннем) слое и один нейрон в выходном слое.
// Часть 1.
// В этом проекте еще не полная нейронная сеть. Здесь мы создали несколько классов (в соответствии с исходной статььей).
// Можно было обойтись и меньшим количеством классов.
// Создали 6 нейронов:
//     class Network - List<Neuron> neurons = Arrays.asList
//
// Массив data - входные данные - Рост и Вес
// Массив answers - ответы - Мужчина или Женщина
// Пример нейронной сети, который взят за образец, использовал небольшой массив data с заданным Ростом и Весом
// и определял, Мужчина это или Женщина
//
// Метод public Double predict(Integer input1, Integer input2) использует входные данные input1-Рост и input2-Вес
// и здесь реализована работа слоев нейронов - передача результатов в слои. Собственно вычисления (внутри нейрона) -
// выполняются в public double compute(double input1, double input2). Причем, в внутреннем и выходном слое параметры
// input1 и input2 это уже не Рост и Вес, а вычисленные в входном слое коэффициенты в диапазоне 0 - 1.
// В листинг добавлено много сообщений в Log i, показывающих промежуточные результаты
//
// Если разместить проект в папке с адресом C:\Users\vall\AndroidStudioProjects\SimpleNNeuron
// то настраивать его перед запуском не придётся
//
// Скачать части проекта:
//
// http://site.oflameron.ru/
// http://multidoc.oflameron.com/page003.htm
// http://gunner.vov.ru/page0003.htm
// http://webpage.pips.ru/ipv6.htm
// http://build.dtn.ru/
// http://czechentropy.freetzi.com/
//
// Теперь надо учить сеть.
// Часть 2.

//--------------------------------------------------------------
public class App {
    public static Integer neuronnum = 0; // Номер Нейрона
    public static void main( String[] args ) {
        //App app = new App();
        //app.trainAndPredict(); // Начинает работать с этого - заполняем массивы данными и ответами
    }


    public void trainAndPredict() { // Начинает работу с вызова этого метода в main
        Integer data [][] = new Integer[4][4]; // Двумерный массив РОСТ, ВЕС. По 4 значения
        // Заполняем значениями
        // 4 пары значений РОСТ, ВЕС
        data[0][0] = 115; // Рост
        data[0][1] = 66; // Вес

        data[1][0] = 175; // Рост
        data[1][1] = 78; // Вес

        data[2][0] = 205; // Рост
        data[2][1] = 72; // Вес

        data[3][0] = 120; // Рост
        data[3][1] = 67; // Вес

        // Ответы для заданных выше пар входных значений
        // Ответы для data - 1.0 - женщина, а 0,0 — мужчина
        Double answers [] = new Double[4];
        answers[0] = 1.0; // Женщина
        answers[1] = 0.0; // Мужчина
        answers[2] = 0.0; // Мужчина
        answers[3] = 1.0; // Женщина

                                                                // 1.0 - женщина, а 0,0 — мужчина


        // Создаем сеть из 6 нейронов, задаем входные згачения и пишем на экран результат
        Network network1000 = new Network(); // Вызов класса Network, метод predict - создаем сеть Network1000
        Double Te = network1000.predict(data[0][0],data[0][1]); // predict(Рост,Вес) - Return Double
        Log.i("== TRAIN =", " == == network1000.predict == == Double Te=" + String.valueOf(Te));


/*
        List<Object> nlist = Arrays.asList(new Neuron(), 0, new Neuron(), 1, new Neuron(), 2,
                new Neuron(), 3, new Neuron(), 4,
                new Neuron(), 5);
        System.out.println("\n==== nlist.get(1) ====" + String.valueOf(nlist.get(1))); // new int[0]
 */

    }
} // App

//--------------------------------------------------------------------

class Network { // Вызывается из класса App
    int epochs = 0; //1000;
    Double learnFactor = null;
    App nrn = new App(); // Экземпляр класса

    /*
    // Комбинированный расширяемый список
    // Нейроны и их номер (для придания наглядности выводимым в Log данным)
    List<Object> neurons = Arrays.asList(new Neuron(), 0, new Neuron(), 1, new Neuron(), 2, // Входной уровень
            new Neuron(), 3, new Neuron(), 4,                                               // Скрытый уровень
            new Neuron(), 5);                                                               // Выходной уровень
*/

    List<Neuron> neurons = Arrays.asList( // Расширяемый список нейронов из класса Neuron
            new Neuron(), new Neuron(), new Neuron(),   // Входной уровень
            new Neuron(), new Neuron(),                 // Скрытый уровень
            new Neuron());                              // Выходной уровень

    //----- Прогнозирование --------------------------------
    // Два входных сигнала input1(Рост) и input2(Вес) подаются в первые три нейрона 0,1 и 2, выходные данные
    // которых затем передаются по конвейеру в нейроны 3 и 4, которые,
    // в свою очередь, передаются в выходной нейрон 5.
    // Этот процесс известен как прямая связь
    public Double predict(Integer input1, Integer input2){ // Предсказывать. На вход подавать Рост и Вес
        // Neuron nrn = new Neuron(); // Экземпляр класса
        Log.i("== TRAIN =", " == == predict Neuron(input1, input2) == == input1=" + String.valueOf(input1));
        Log.i("== TRAIN =", " == == predict Neuron(input1, input2) == == input2=" + String.valueOf(input2));
        Log.i("== TRAIN =", " == ===================================================================== == ");
        return neurons.get(5).compute( // Где neurons - это List<Neuron> neurons = Arrays.asList(new Neuron(), new Neuron(), new Neuron(),new Neuron(), new Neuron(),new Neuron());
                neurons.get(4).compute( // Compute - начальная активация. class Neuron
                        neurons.get(2).compute(input1, input2, 2), // compute - здесь - СИГМОИД - Util.sigmoid(preActivation)
                        neurons.get(1).compute(input1, input2, 1),4  // compute - здесь - СИГМОИД - Util.sigmoid(preActivation)
                ),
                neurons.get(3).compute(
                        neurons.get(1).compute(input1, input2,1), // Получить из списка neurons ПЕРВЫЙ элемент (нейрон) с входными значениями input1, input2
                        neurons.get(0).compute(input1, input2,0),3  // compute - здесь - СИГМОИД - Util.sigmoid(preActivation)
                ),5
        );
    }


} // Network


//--------------------------------------------------------------------


class Neuron { // Нейрон   https://belsap.com/2019/03/%D0%BD%D0%B5%D0%B9%D1%80%D0%BE%D0%BD%D0%BD%D1%8B%D0%B5-%D1%81%D0%B5%D1%82%D0%B8-%D0%B4%D0%BB%D1%8F-%D0%BD%D0%B0%D1%87%D0%B8%D0%BD%D0%B0%D1%8E%D1%89%D0%B8%D1%85/

    //----- Инициализация нейрона --------------------------------
    // Нейрон с двумя входами, поэтому два ВЕСА, одно смещение и некая функция активации
    private Double oldBias = randomnextDouble(-1, 1); // Bias - смещение
    public Double oldWeight1 = randomnextDouble(-1, 1); // Вес 1
    private Double oldWeight2 = randomnextDouble(-1, 1); // Вес 2

    private Double bias = randomnextDouble(-1, 1); // Bias - смещение
    public Double weight1 = randomnextDouble(-1, 1); // Вес 1
    private Double weight2 = randomnextDouble(-1, 1); // Вес 2



    //----- Функция активации нейрона. Самая простая -------------
    // Функция активации - от RND заполняется Вес1, Вес2 и смещение для каждого нейрона
    public double randomnextDouble(double start, double end) { // Random DOUBLE
        double random = new Random().nextInt();
        double result = start + (random * (end - start));
        return (result);
    }



    //----- Вычисляем выходные данные нейрона --------------------------
    // Когда мы вычисляем выходные данные нейрона, мы следуем алгоритму:
    // умножаем каждый входной сигнал на его вес плюс
    // смещение: вход1 * вес1 + вход2 * вес2 + смещение . Это дает нам необработанные
    // вычисления (т. е. preActivation), которые мы запускаем через функцию активации.
    // В этом случае мы используем функцию активации Sigmoid , которая сжимает значения
    // в диапазон от -1 до 1. В листинге 2 показан Util.sigmoid()статический метод.
    public double compute(double input1, double input2, int nnum){ // Вычисляем выходные данные нейрона nnum
//      this.input1 = input1;  this.input2 = input2;
        Log.i("== TRAIN =", " == == Neuron Number == == " + String.valueOf(nnum));
        Log.i("== TRAIN =", " == == public Double predict == == weight1=" + String.valueOf(weight1));
        Log.i("== TRAIN =", " == == public Double predict == == weight2=" + String.valueOf(weight2));
        Log.i("== TRAIN =", " == == public Double predict == == bias=" + String.valueOf(bias));
        // preActivation - необработанные данные нейрона (от фонаря) - до Сигмоида
        double preActivation = (this.weight1 * input1) + (this.weight2 * input2) + this.bias; // Вес 1*Вход 1 + Вес 2*Вход 2 * Смещение
        Log.i("== TRAIN =", " == == public Double predict == == input1=" + String.valueOf(input1) + " input2=" + String.valueOf(input2));
        Log.i("== TRAIN =", " == == public Double predict == == weight1 * input1=" + String.valueOf(this.weight1 * input1));
        Log.i("== TRAIN =", " == == public Double predict == == weight2 * input2=" + String.valueOf(this.weight2 * input2));
        // Пропускаем необработанные данные preActivation - через Сигмоид
        double output = Util.sigmoid(preActivation); // Диапазон значений output -
        // [0,1]. Класс Util функция активации(метод) sigmoid(preActivation)
        // Здесь preActivation - необработанные вычисления - умножанные каждый входной сигнал на его вес плюс смещение:
        // вход1 * вес1 + вход2 * вес2 + смещение
        Log.i("== TRAIN =", " == == public Double predict == == Util.sigmoid(preActivation)=" + String.valueOf(output) + " <-- Neuron Output");
        Log.i("== TRAIN =", " == ===================================================================== == ");
        return output;
    }

} // Neuron

//--------------------------------------------------------------------

//----- Функция активации - СИГМОИД ----------------------------
class Util {
    public static double sigmoid(double in){ // Функция активации - СИГМОИД. Диапазон значений [0,1]
        // Здесь in - это preActivation = вход1 * вес1 + вход2 * вес2 + смещение

        return 1 / (1 + Math.exp(-in));  // Сигмоид. Сжимает значения в диапазон от -1 до 1
    }

    public static double sigmoidDeriv(double in){
        double sigmoid = Util.sigmoid(in);
        return sigmoid * (1 - in);
    }

    //------------------------------------------------------------
    /** Предполагается, что аргументы массива имеют одинаковую длину - Assumes array args are same length */
    // Средняя квадратичная ошибка
    //------------------------------------------------------------
    // Мы можем проверить результаты, используя формулу среднеквадратической ошибки (MSE) — распространенный способ
    // проверки набора результатов в нейронной сети
    public static Double meanSquareLoss(List<Double> correctAnswers, List<Double> predictedAnswers){
        double sumSquare = 0;
        for (int i = 0; i < correctAnswers.size(); i++){
            double error = correctAnswers.get(i) - predictedAnswers.get(i);
            sumSquare += (error * error); // Средняя квадратичная ошибка
        }
        return sumSquare / (correctAnswers.size());
    }
} // Util class

